﻿using ClosedXML.Excel;
using Newtonsoft.Json.Linq;
using NLog;
using System;
using System.Data;
using System.Linq;
using System.Windows.Forms;
using System.Text.RegularExpressions;



namespace excel2kintone_update
{
    public partial class Form1 : Form
    {

        private static readonly Logger logger = LogManager.GetCurrentClassLogger();


        JObject objConf = new JObject();
        JObject confFields = new JObject();


        JArray arrRows = new JArray();
        JArray arrKintoneRecs = new JArray();
        JObject objExcelSlected = new JObject();
        JArray excelMap;
        string KEY_FIELD;

        Kintone kintone;



        public Form1()
        {
            InitializeComponent();
            //objConf["domain"] = "tox1i0lgjy5s";
            //objConf["space_id"] = 0;
            //objConf["app_id"] = 549;
            //objConf["api_token"] = "UOEJFvyRsOqqiJIirT3NLy47F27T2cP49zEGvMTJ";
            //System.IO.File.WriteAllText("confKintone.json", objConf.ToString());

            objConf = JObject.Parse(System.IO.File.ReadAllText(@"confKintone.json"));

            kintone = new Kintone(objConf["domain"].ToString(), (int)objConf["space_id"], (int)objConf["app_id"], objConf["api_token"].ToString(), null);

            confFields = JObject.Parse(System.IO.File.ReadAllText(@"confFields.json"));
            KEY_FIELD = confFields["key_field"].ToString();

            //logger.Info(excelMap.ToString());

        }


        public JArray readExcel2(string excel_file)
        {
            excelMap = JArray.Parse(System.IO.File.ReadAllText(@"excelMap.json"));

            using (var workbook = new XLWorkbook(excel_file))
            {
                var worksheet = workbook.Worksheet(1);
                var maxRow = workbook.Worksheet(1).LastRowUsed().RowNumber();
                JArray arrRows = new JArray();

                for (int i = 2; i <= maxRow; i++)
                {
                    JObject objRow = new JObject();
                    foreach (var item in excelMap)
                    {
                        string field = item["列名"].ToString();
                        int index = (int)item["列インデックス"];
                        objRow[field] = convDate(worksheet.Cell(i, index).Value.ToString());

                        //logger.Info($"{convDate(objRow[field].ToString())} - {objRow[field]}");
                    }

                    arrRows.Add(objRow);
                }

                return arrRows;
            }
        }


        private void listKey_SelectedIndexChanged(object sender, EventArgs e)
        {
            listKey.SelectedItem.ToString();
            objExcelSlected = arrRows.FirstOrDefault(item => item[KEY_FIELD].ToString() == listKey.SelectedItem.ToString()) as JObject;

            string phase = objExcelSlected["フェーズ"].ToString();

            txtExcel.Text = "";
            txtExcel.AppendText($"部品番号:{objExcelSlected["部品番号"]}" + Environment.NewLine);
            string yotei_val = objExcelSlected["予定"].ToString();
            string jisseki_val = objExcelSlected["実績"].ToString();
            string kosuu_val = objExcelSlected["個数"].ToString();
            string bikou_val = objExcelSlected["備考"].ToString();
            txtExcel.AppendText($"フェーズ:{phase}" + Environment.NewLine);
            txtExcel.AppendText($"予定:{yotei_val}" + Environment.NewLine);
            txtExcel.AppendText($"実績:{jisseki_val}" + Environment.NewLine);
            txtExcel.AppendText($"個数:{kosuu_val}" + Environment.NewLine);
            txtExcel.AppendText($"備考:{bikou_val}" + Environment.NewLine);

            JArray arrFields2 = new JArray { "部品番号", $"{phase}予定", $"{phase}実績", $"{phase}個数", $"{phase}備考" };

            arrKintoneRecs = kintone.GetAllRecords(arrFields2, KEY_FIELD);
            txtMsg.AppendText(arrKintoneRecs.ToString() + Environment.NewLine);

            JObject objKintone = arrKintoneRecs.FirstOrDefault(item => item[KEY_FIELD]["value"].ToString() == listKey.SelectedItem.ToString()) as JObject;

            if (objKintone != null)
            {
                txtKintone.Text = "";
                foreach (var field in arrFields2)
                {
                    txtKintone.AppendText($"{field}:{objKintone[field.ToString()]["value"]}" + Environment.NewLine);
                }
            }
            else
            {
                txtKintone.Text = "No record found";
            }

        }


        private void button4_Click(object sender, EventArgs e)
        {
            arrRows = readExcel2("更新用.xlsx");
            txtMsg.AppendText(arrRows.ToString() + Environment.NewLine);
            var arrSorted = arrRows.Select(item => item[KEY_FIELD].ToString());
            listKey.Items.Clear();
            foreach (var item in arrSorted)
            {
                txtMsg.AppendText(item + Environment.NewLine);
                listKey.Items.Add(item);
            }
        }


        private void button5_Click(object sender, EventArgs e)
        {
            string key_val = listKey.SelectedItem.ToString();

            string phase = objExcelSlected["フェーズ"].ToString();

            JObject obj = new JObject
            {
                ["app"] = (int)objConf["app_id"],
                ["updateKey"] = new JObject()
            };
            obj["updateKey"]["field"] = KEY_FIELD;
            obj["updateKey"]["value"] = key_val;
            obj["record"] = new JObject();

            var rec = excelMap.Select(item => item["列名"].ToString()).Where(item => item != "部品番号" && item != "フェーズ");
            foreach (var fld in rec)
            {

                if (objExcelSlected[fld].ToString() != "")
                {
                    obj["record"][$"{phase}{fld}"] = new JObject
                    {
                        ["value"] = objExcelSlected[fld].ToString()
                    };
                }
            }

            txtMsg.Text = "";
            txtMsg.AppendText($"obj:{obj}" + Environment.NewLine);

            JObject ret = kintone.data_update2(obj);
            txtMsg.AppendText(ret.ToString() + Environment.NewLine);
        }


        private string convDate(string str)
        {
            if (Regex.IsMatch(str, @"^\d{4}/\d{2}/\d{2}") == true)
            {
                return Convert.ToDateTime(str).ToString("yyyy-MM-dd");
            }
            else
            {
                return str;
            }
        }
    }
}
